Attribute VB_Name = "modFrmMinMax"
Option Explicit

Private Const GWL_WNDPROC = -4
Private Const WM_GETMINMAXINFO = &H24

Private WinOldProc As Long
Private spR As SIZEPAR
Private Frm As Form

Private Declare Function DefWindowProc Lib "user32" _
                         Alias "DefWindowProcA" ( _
                         ByVal hWnd As Long, _
                         ByVal wMsg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long

Private Declare Function SetWindowLong Lib "user32" _
                         Alias "SetWindowLongA" ( _
                         ByVal hWnd As Long, _
                         ByVal nIndex As Long, _
                         ByVal dwNewLong As Long) As Long

Private Declare Function CallWindowProc Lib "user32" _
                         Alias "CallWindowProcA" ( _
                         ByVal lpPrevWndFunc As Long, _
                         ByVal hWnd As Long, _
                         ByVal msg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long

Private Declare Sub RtlMoveMemory Lib "kernel32" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)

Public Type SIZEPAR
    xMin As Long
    xMax As Long
    yMin As Long
    yMax As Long
End Type

Private Type POINTAPI
    x As Long
    y As Long
End Type

Private Type MINMAXINFO
    ptReserved As POINTAPI
    ptMaxSize As POINTAPI
    ptMaxPosition As POINTAPI
    ptMinTrackSize As POINTAPI
    ptMaxTrackSize As POINTAPI
End Type

Public Sub Init(F As Form, r As SIZEPAR)

    spR = r

    Set Frm = F

    WinOldProc = SetWindowLong(Frm.hWnd, GWL_WNDPROC, AddressOf WindowProc)

End Sub

Public Sub Unhook()

    Call SetWindowLong(Frm.hWnd, GWL_WNDPROC, WinOldProc)

End Sub

Private Function WindowProc(ByVal hWnd&, ByVal uMsg&, ByVal wParam&, ByVal _
    lParam&) As Long

    Dim Result As Long

    If uMsg = WM_GETMINMAXINFO And Frm.WindowState = 0 Then

        Dim MM As MINMAXINFO

        Call RtlMoveMemory(MM, lParam, Len(MM))

        With MM

            .ptMaxPosition.x = 0
            .ptMaxPosition.y = 0
            .ptMaxSize.x = Screen.Width / Screen.TwipsPerPixelX
            .ptMaxSize.y = Screen.Height / Screen.TwipsPerPixelY
            .ptMinTrackSize.x = spR.xMin
            .ptMinTrackSize.y = spR.yMin
            .ptMaxTrackSize.x = spR.xMax
            .ptMaxTrackSize.y = spR.yMax

        End With

        Call RtlMoveMemory(ByVal lParam&, MM, Len(MM))

        Result = DefWindowProc(hWnd, uMsg, wParam, lParam)

    Else

        Result = CallWindowProc(WinOldProc, hWnd, uMsg, wParam, lParam)

    End If

    WindowProc = Result

End Function
