Attribute VB_Name = "modMFPlayer"
Option Explicit

' ----==== Public Enums ====----
Public Enum D3DPOOL
    D3DPOOL_DEFAULT = 0&
    D3DPOOL_MANAGED = 1&
    D3DPOOL_SYSTEMMEM = 2&
    D3DPOOL_SCRATCH = 3&
End Enum

Public Enum MFRATE_DIRECTION
    MFRATE_FORWARD = &H0&
    MFRATE_REVERSE = &H1&
End Enum

Public Enum MFCLOCK_STATE
    MFCLOCK_STATE_INVALID = &H0&
    MFCLOCK_STATE_RUNNING = &H1&
    MFCLOCK_STATE_STOPPED = &H2&
    MFCLOCK_STATE_PAUSED = &H3&
End Enum

Public Enum D3DTEXTUREFILTERTYPE
    D3DTEXF_NONE = 0&
    D3DTEXF_POINT = 1&
    D3DTEXF_LINEAR = 2&
    D3DTEXF_ANISOTROPIC = 3&
    D3DTEXF_PYRAMIDALQUAD = 6&
    D3DTEXF_GAUSSIANQUAD = 7&
    D3DTEXF_CONVOLUTIONMONO = 8&
End Enum

Public Enum MFVideoProcAmpSettings
    DXVA2_ProcAmp_None = &H0&
    DXVA2_ProcAmp_Brightness = &H1&
    DXVA2_ProcAmp_Contrast = &H26
    DXVA2_ProcAmp_Hue = &H4&
    DXVA2_ProcAmp_Saturation = &H8&
End Enum

Public Enum MFVideoFilteringSettings
    DXVA2_NoiseFilterLumaLevel = 1&
    DXVA2_NoiseFilterLumaThreshold = 2&
    DXVA2_NoiseFilterLumaRadius = 3&
    DXVA2_NoiseFilterChromaLevel = 4&
    DXVA2_NoiseFilterChromaThreshold = 5&
    DXVA2_NoiseFilterChromaRadius = 6&
    DXVA2_DetailFilterLumaLevel = 7&
    DXVA2_DetailFilterLumaThreshold = 8&
    DXVA2_DetailFilterLumaRadius = 9&
    DXVA2_DetailFilterChromaLevel = 10&
    DXVA2_DetailFilterChromaThreshold = 11&
    DXVA2_DetailFilterChromaRadius = 12&
End Enum

Public Enum MFVideoAlphaBitmapFlags
    MFVideoAlphaBitmap_EntireDDS = 1&
    MFVideoAlphaBitmap_SrcColorKey = 2&
    MFVideoAlphaBitmap_SrcRect = 4&
    MFVideoAlphaBitmap_DestRect = 8&
    MFVideoAlphaBitmap_FilterMode = 16&
    MFVideoAlphaBitmap_Alpha = 32&
    MFVideoAlphaBitmap_BitMask = 63&
End Enum

Public Enum MFVideoAspectRatioMode
    MFVideoARMode_None = &H0&
    MFVideoARMode_PreservePicture = &H1&
    MFVideoARMode_PreservePixel = &H2&
    MFVideoARMode_NonLinearStretch = &H4&
    MFVideoARMode_Mask = &H7&
End Enum

Public Enum MFVideoRenderPrefs
    MFVideoRenderPrefs_DoNotRenderBorder = 1&
    MFVideoRenderPrefs_DoNotClipToDevice = 2&
    MFVideoRenderPrefs_AllowOutputThrottling = 4&
    MFVideoRenderPrefs_ForceOutputThrottling = 8&
    MFVideoRenderPrefs_ForceBatching = 16&
    MFVideoRenderPrefs_AllowBatching = 32&
    MFVideoRenderPrefs_ForceScaling = 64&
    MFVideoRenderPrefs_AllowScaling = 128&
    MFVideoRenderPrefs_DoNotRepaintOnStop = 256&
    MFVideoRenderPrefs_Mask = 511&
End Enum


Public Enum DXVA2_VPDev_FLAGS
    DXVA2_VPDev_HardwareDevice = &H1&
    DXVA2_VPDev_EmulatedDXVA1 = &H2&
    DXVA2_VPDev_SoftwareDevice = &H4&
    DXVA2_VPDev_Mask = &H7&
End Enum

' ----==== Public Types ====----
Public Type SIZE
    cx As Long
    cy As Long
End Type

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type PROPERTYKEY
    fmtid As GUID
    pid As Long
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

Public Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

Public Type BITMAPFILEHEADER
    bfType As Integer
    bfSize As Long
    bfReserved1 As Integer
    bfReserved2 As Integer
    bfOffBits As Long
End Type

Public Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type MFVideoNormalizedRect
    Left As Single
    Top As Single
    Right As Single
    Bottom As Single
End Type

Public Type MFARGB
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbAlpha As Byte
End Type

Public Type MFVideoAlphaBitmapParams
    dwFlags As MFVideoAlphaBitmapFlags
    clrSrcKey As Long
    rcSrc As RECT
    nrcDest As MFVideoNormalizedRect
    fAlpha As Single
    dwFilterMode As Long
End Type

Public Type MFVideoAlphaBitmap
    GetBitmapFromDC As Long
    HDCOrDDS As Long
    Params As MFVideoAlphaBitmapParams
End Type

Public Type DXVA2_Fixed32
   Fraction As Integer
   Value As Integer
End Type

Public Type DXVA2_ValueRange
    MinValue As DXVA2_Fixed32
    MaxValue As DXVA2_Fixed32
    DefaultValue As DXVA2_Fixed32
    StepSize As DXVA2_Fixed32
End Type

Public Type DXVA2_ProcAmpValues
    Brightness As DXVA2_Fixed32
    Contrast As DXVA2_Fixed32
    Hue As DXVA2_Fixed32
    Saturation As DXVA2_Fixed32
End Type

Public Type DXVA2_VideoProcessorCaps
    DeviceCaps As DXVA2_VPDev_FLAGS
    InputPool As D3DPOOL
    NumForwardRefSamples As Long
    NumBackwardRefSamples As Long
    Reserved As Long
    DeinterlaceTechnology As Long
    ProcAmpControlCaps As Long
    VideoProcessorOperations As Long
    NoiseFilterTechnology As Long
    DetailFilterTechnology As Long
End Type
